<template>
  <div>
    <form class="form" @submit.prevent="addTodo">
      <!-- Creating a form with an input field for adding new tasks. -->
      <input class="input" v-model="newTodo" placeholder="Add a todo" />
      <button class="add" type="submit">Add</button
      ><!-- Creating the submit button. -->
    </form>
    <ul>
      <li v-for="(todo, index) in todos" :key="index">
        <!-- using v-for directive allows us to iterate over an array to display data. -->
        <span
          :style="{
            textDecoration: todo.strikethrough ? 'line-through' : 'none',
          }"
          >{{ todo.text }}</span
        >
        <button class="buttons" @click="updateTodo(index)">Update</button
        ><!-- Edit button that allows the user to update the task. -->
        <button class="buttons" @click="deleteTodo(index)">Delete</button
        ><!-- Delete button that allows the user to delete the task. -->

        <button class="buttons" @click="toggleStrikethrough(index)">
          Done
        </button>
      </li>
    </ul>
  </div>
</template>

<!-- All the design is in here -->
<style>
body {
  font-family: Arial, Helvetica, sans-serif;
  background-color: gray;
}
.container {
  width: 500px;
  margin: 20px auto;
}
.form {
  background-color: #eee;
  border-radius: 6px;
  padding: 20px;
  display: flex;
  align-items: center;
}
.input {
  padding: 10px;
  border: 1px solid #ddd;
  border-radius: 6px;
  flex: 1;
}
.input:focus,
.add:focus {
  outline: none;
}
.add {
  border: none;
  background-color: #f44336;
  color: white;
  padding: 10px;
  border-radius: 6px;
  margin-left: 10px;
  cursor: pointer;
}
.tasks {
  background-color: #eee;
  border-radius: 6px;
  padding: 20px;
  display: flex;
  align-items: center;
}
.tasks .task {
  background-color: white;
  padding: 10px;
  border-radius: 6px;
  display: flex;
  justify-content: space-between;
  align-items: center;
  transition: 0.3s;
  cursor: pointer;
  border: 1px solid #ccc;
}
.tasks .task:not(:last-child) {
  margin-bottom: 15px;
}
.tasks .task:hover {
  background-color: #f7f7f7;
}
.tasks .task.done {
  opacity: 0.5;
  position: relative;
}
.task.done::after {
  position: absolute;
  content: "";
}
.tasks .task span {
  font-weight: bold;
  font-size: 10px;
  background-color: red;
  color: white;
  padding: 2px 6px;
  border-radius: 4px;
  cursor: pointer;
}
.buttons {
  padding: 5px;
  text-align: center;
  font-size: 14px;
  color: white;
  background-color: #f44336;
  margin-top: 20px;
  cursor: pointer;
  border-radius: 4px;
}
</style>

<script>
//define default values
export default {
  data() {
    return {
      newTodo: "",
      todos: [],
    };
  },
  methods: {
    // adding or input new todo to list and if no value"string" is submitted alert
    addTodo() {
      if (!this.newTodo) {
        alert("Please enter a value");
        return;
      }
      this.todos.push({ text: this.newTodo, strikethrough: false });
      this.newTodo = "";
    },
    // add striketrough to do from list when button done is clicked
    toggleStrikethrough(index) {
      this.todos[index].strikethrough = !this.todos[index].strikethrough;
    },
    // Update or modify to do from list array
    updateTodo(index) {
      const newValue = prompt("Enter new value");
      if (!newValue) {
        alert("Please enter a value");
        return;
      }
      this.todos[index].text = newValue;
    },
    // Delete to do from list array
    deleteTodo(index) {
      this.todos.splice(index, 1);
    },
  },
};
</script>
